#ifndef __syntaxhighlightdlg__
#define __syntaxhighlightdlg__

/**
@file
Subclass of SyntaxHighlightBaseDlg, which is generated by wxFormBuilder.
*/

#include "syntaxhighlightbasedlg.h"
#include "lexer_configuration.h"
class wxChoice;
class wxNotebook;

/** Implementing SyntaxHighlightBaseDlg */
class SyntaxHighlightDlg : public SyntaxHighlightBaseDlg
{
	wxChoice* m_themes;
	wxNotebook *m_lexersBook;
	wxString m_startingTheme;
	
protected:
	// Handlers for SyntaxHighlightBaseDlg events.
	void OnButtonOK( wxCommandEvent& event );
	void OnButtonCancel( wxCommandEvent& event );
	void OnButtonApply( wxCommandEvent& event );
	void OnThemeChanged(wxCommandEvent& event);
	
	wxPanel *CreateSyntaxHighlightPage();
	void LoadLexers(const wxString& theme);	
	wxPanel *CreateLexerPage(wxWindow *parent, LexerConfPtr lexer);
	void SaveChanges();
	
public:
	/** Constructor */
	SyntaxHighlightDlg( wxWindow* parent );
};

#endif // __syntaxhighlightdlg__
