#ifndef __virtualdirectoryselector__
#define __virtualdirectoryselector__

/**
@file
Subclass of VirtualDirectorySelectorBase, which is generated by wxFormBuilder.
*/

#include "virtualdirectoryselectorbase.h"
class Workspace;

/** Implementing VirtualDirectorySelectorBase */
class VirtualDirectorySelector : public VirtualDirectorySelectorBase
{
	Workspace *m_workspace;
	wxString m_initialPath;
	
public:
	static wxString DoGetPath(wxTreeCtrl* tree, const wxTreeItemId &item, bool validateFolder);
	
protected:
	void DoBuildTree();
	
protected:
	// Handlers for VirtualDirectorySelectorBase events.
	void OnItemSelected( wxTreeEvent& event );
	void OnButtonOK( wxCommandEvent& event );
	void OnButtonCancel( wxCommandEvent& event );
	void OnButtonOkUI(wxUpdateUIEvent &event);
	
public:
	/** Constructor */
	VirtualDirectorySelector( wxWindow* parent, Workspace *wsp, const wxString &initialPath = wxEmptyString );
	wxString GetVirtualDirectoryPath() const {return m_staticTextPreview->GetLabel();}
	bool SelectPath(const wxString &path);
};

#endif // __virtualdirectoryselector__
